summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
-rwxr-xr-xsrc/monkeysphere-authentication138
-rwxr-xr-xsrc/monkeysphere-host187
-rwxr-xr-xsrc/subcommands/ma/diagnostics12
-rwxr-xr-xsrc/subcommands/ma/update-users144
-rwxr-xr-xsrc/subcommands/mh/gen-key118
-rwxr-xr-xsrc/subcommands/mh/import-key85
6 files changed, 359 insertions, 325 deletions
diff --git a/src/monkeysphere-authentication b/src/monkeysphere-authentication
index 71ca91f..cac0e18 100755
--- a/src/monkeysphere-authentication
+++ b/src/monkeysphere-authentication
@@ -134,144 +134,6 @@ check_host_keyring() {
|| failure "You don't appear to have a Monkeysphere host key on this server. Please run 'monkeysphere-server gen-key' first."
}
-# update authorized_keys for users
-update_users() {
- if [ "$1" ] ; then
- # get users from command line
- unames="$@"
- else
- # or just look at all users if none specified
- unames=$(getent passwd | cut -d: -f1)
- fi
-
- RETCODE=0
-
- # set mode
- MODE="authorized_keys"
-
- # set gnupg home
- GNUPGHOME="$GNUPGHOME_AUTHENTICATION"
-
- # check to see if the gpg trust database has been initialized
- if [ ! -s "${GNUPGHOME}/trustdb.gpg" ] ; then
- failure "GNUPG trust database uninitialized. Please see MONKEYSPHERE-SERVER(8)."
- fi
-
- # make sure the authorized_keys directory exists
- mkdir -p "${SYSDATADIR}/authorized_keys"
-
- # loop over users
- for uname in $unames ; do
- # check all specified users exist
- if ! id "$uname" >/dev/null ; then
- log error "----- unknown user '$uname' -----"
- continue
- fi
-
- log verbose "----- user: $uname -----"
-
- # make temporary directory
- TMPLOC=$(mktemp -d ${MSTMPDIR}/tmp.XXXXXXXXXX) || failure "Could not create temporary directory!"
-
- # trap to delete temporary directory on exit
- trap "rm -rf $TMPLOC" EXIT
-
- # create temporary authorized_user_ids file
- TMP_AUTHORIZED_USER_IDS="${TMPLOC}/authorized_user_ids"
- touch "$TMP_AUTHORIZED_USER_IDS"
-
- # create temporary authorized_keys file
- AUTHORIZED_KEYS="${TMPLOC}/authorized_keys"
- touch "$AUTHORIZED_KEYS"
-
- # set restrictive permissions on the temporary files
- # FIXME: is there a better way to do this?
- chmod 0700 "$TMPLOC"
- chmod 0600 "$AUTHORIZED_KEYS"
- chmod 0600 "$TMP_AUTHORIZED_USER_IDS"
- chown -R "$MONKEYSPHERE_USER" "$TMPLOC"
-
- # process authorized_user_ids file
- log debug "checking for authorized_user_ids..."
- # translating ssh-style path variables
- authorizedUserIDs=$(translate_ssh_variables "$uname" "$AUTHORIZED_USER_IDS")
- if [ -s "$authorizedUserIDs" ] ; then
- # check permissions on the authorized_user_ids file path
- if check_key_file_permissions "$uname" "$authorizedUserIDs" ; then
- # copy user authorized_user_ids file to temporary
- # location
- cat "$authorizedUserIDs" > "$TMP_AUTHORIZED_USER_IDS"
-
- # export needed variables
- export AUTHORIZED_KEYS
- export TMP_AUTHORIZED_USER_IDS
-
- # process authorized_user_ids file, as monkeysphere
- # user
- su_monkeysphere_user \
- ". ${SYSSHAREDIR}/common; process_authorized_user_ids $TMP_AUTHORIZED_USER_IDS"
- RETURN="$?"
- else
- log debug "not processing authorized_user_ids."
- fi
- else
- log debug "empty or absent authorized_user_ids file."
- fi
-
- # add user-controlled authorized_keys file if specified
- # translate ssh-style path variables
- rawAuthorizedKeys=$(translate_ssh_variables "$uname" "$RAW_AUTHORIZED_KEYS")
- if [ "$rawAuthorizedKeys" != 'none' ] ; then
- log debug "checking for raw authorized_keys..."
- if [ -s "$rawAuthorizedKeys" ] ; then
- # check permissions on the authorized_keys file path
- if check_key_file_permissions "$uname" "$rawAuthorizedKeys" ; then
- log verbose "adding raw authorized_keys file... "
- cat "$rawAuthorizedKeys" >> "$AUTHORIZED_KEYS"
- else
- log debug "not adding raw authorized_keys file."
- fi
- else
- log debug "empty or absent authorized_keys file."
- fi
- fi
-
- # move the new authorized_keys file into place
- if [ -s "$AUTHORIZED_KEYS" ] ; then
- # openssh appears to check the contents of the
- # authorized_keys file as the user in question, so the
- # file must be readable by that user at least.
-
- # but in general, we don't want the user tampering with
- # this file directly, so we'll adopt this approach: Own
- # the file by the monkeysphere-server invoker (usually
- # root, but should be the same uid that sshd is launched
- # as); change the group of the file so that members of the
- # user's group can read it.
-
- # FIXME: is there a better way to do this?
- chown $(whoami) "$AUTHORIZED_KEYS" && \
- chgrp $(id -g "$uname") "$AUTHORIZED_KEYS" && \
- chmod g+r "$AUTHORIZED_KEYS" && \
- mv -f "$AUTHORIZED_KEYS" "${SYSDATADIR}/authorized_keys/${uname}" || \
- {
- log error "Failed to install authorized_keys for '$uname'!"
- rm -f "${SYSDATADIR}/authorized_keys/${uname}"
- # indicate that there has been a failure:
- RETURN=1
- }
- else
- rm -f "${SYSDATADIR}/authorized_keys/${uname}"
- fi
-
- # unset the trap
- trap - EXIT
-
- # destroy temporary directory
- rm -rf "$TMPLOC"
- done
-}
-
diagnostics() {
# * check on the status and validity of the key and public certificates
local seckey
diff --git a/src/monkeysphere-host b/src/monkeysphere-host
index 9eed3ac..830646a 100755
--- a/src/monkeysphere-host
+++ b/src/monkeysphere-host
@@ -160,193 +160,6 @@ show_server_key() {
return $ret
}
-# import an existing ssh key to a gpg key
-import_key() {
- local hostName=$(hostname -f)
- local keyFile="/etc/ssh/ssh_host_rsa_key"
- local keyExpire
- local userID
-
- # check for presense of secret key
- # FIXME: is this the proper test to be doing here?
- fingerprint_server_key >/dev/null \
- && failure "An OpenPGP host key already exists."
-
- # get options
- while true ; do
- case "$1" in
- -h|--hostname)
- hostName="$2"
- shift 2
- ;;
- -f|--keyfile)
- keyFile="$2"
- shift 2
- ;;
- -e|--expire)
- keyExpire="$2"
- shift 2
- ;;
- *)
- if [ "$(echo "$1" | cut -c 1)" = '-' ] ; then
- failure "Unknown option '$1'.
-Type '$PGRM help' for usage."
- fi
- break
- ;;
- esac
- done
-
- if [ ! -f "$keyFile" ] ; then
- failure "SSH secret key file '$keyFile' not found."
- fi
-
- userID="ssh://${hostName}"
-
- # prompt about key expiration if not specified
- keyExpire=$(get_gpg_expiration "$keyExpire")
-
- echo "The following key parameters will be used for the host private key:"
- echo "Import: $keyFile"
- echo "Name-Real: $userID"
- echo "Expire-Date: $keyExpire"
-
- read -p "Import key? (Y/n) " OK; OK=${OK:=Y}
- if [ ${OK/y/Y} != 'Y' ] ; then
- failure "aborting."
- fi
-
- log verbose "importing ssh key..."
- # translate ssh key to a private key
- (umask 077 && \
- pem2openpgp "$userID" "$keyExpire" < "$sshKey" | gpg_host --import)
-
- # find the key fingerprint of the newly converted key
- fingerprint=$(fingerprint_server_key)
-
- # export host ownertrust to authentication keyring
- log verbose "setting ultimate owner trust for host key..."
- echo "${fingerprint}:6:" | gpg_host "--import-ownertrust"
- echo "${fingerprint}:6:" | gpg_authentication "--import-ownertrust"
-
- # export public key to file
- gpg_authentication "--export-options export-minimal --armor --export 0x${fingerprint}\!" > "${SYSDATADIR}/ssh_host_rsa_key.pub.gpg"
- log info "SSH host public key in OpenPGP form: ${SYSDATADIR}/ssh_host_rsa_key.pub.gpg"
-
- # show info about new key
- show_server_key
-}
-
-# generate server gpg key
-gen_key() {
- local keyType="RSA"
- local keyLength="2048"
- local keyUsage="auth"
- local keyExpire
- local revoker
- local hostName=$(hostname -f)
- local userID
- local keyParameters
- local fingerprint
-
- # check for presense of secret key
- # FIXME: is this the proper test to be doing here?
- fingerprint_server_key >/dev/null \
- && failure "An OpenPGP host key already exists."
-
- # get options
- while true ; do
- case "$1" in
- -h|--hostname)
- hostName="$2"
- shift 2
- ;;
- -l|--length)
- keyLength="$2"
- shift 2
- ;;
- -e|--expire)
- keyExpire="$2"
- shift 2
- ;;
- -r|--revoker)
- revoker="$2"
- shift 2
- ;;
- *)
- if [ "$(echo "$1" | cut -c 1)" = '-' ] ; then
- failure "Unknown option '$1'.
-Type '$PGRM help' for usage."
- fi
- break
- ;;
- esac
- done
-
- userID="ssh://${hostName}"
-
- # prompt about key expiration if not specified
- keyExpire=$(get_gpg_expiration "$keyExpire")
-
- # set key parameters
- keyParameters=\
-"Key-Type: $keyType
-Key-Length: $keyLength
-Key-Usage: $keyUsage
-Name-Real: $userID
-Expire-Date: $keyExpire"
-
- # add the revoker field if specified
- # FIXME: the "1:" below assumes that $REVOKER's key is an RSA key.
- # FIXME: key is marked "sensitive"? is this appropriate?
- if [ "$revoker" ] ; then
- keyParameters=\
-"${keyParameters}
-Revoker: 1:${revoker} sensitive"
- fi
-
- echo "The following key parameters will be used for the host private key:"
- echo "$keyParameters"
-
- read -p "Generate key? (Y/n) " OK; OK=${OK:=Y}
- if [ ${OK/y/Y} != 'Y' ] ; then
- failure "aborting."
- fi
-
- # add commit command
- # must include blank line!
- keyParameters=\
-"${keyParameters}
-
-%commit
-%echo done"
-
- log verbose "generating host key..."
- echo "$keyParameters" | gpg_host --batch --gen-key
-
- # find the key fingerprint of the newly generated key
- fingerprint=$(fingerprint_server_key)
-
- # export host ownertrust to authentication keyring
- log verbose "setting ultimate owner trust for host key..."
- echo "${fingerprint}:6:" | gpg_authentication "--import-ownertrust"
-
- # translate the private key to ssh format, and export to a file
- # for sshs usage.
- # NOTE: assumes that the primary key is the proper key to use
- (umask 077 && \
- gpg_host --export-secret-key "$fingerprint" | \
- openpgp2ssh "$fingerprint" > "${SYSDATADIR}/ssh_host_rsa_key")
- log info "SSH host private key output to file: ${SYSDATADIR}/ssh_host_rsa_key"
- ssh-keygen -y -f "${SYSDATADIR}/ssh_host_rsa_key" > "${SYSDATADIR}/ssh_host_rsa_key.pub"
- log info "SSH host public key output to file: ${SYSDATADIR}/ssh_host_rsa_key.pub"
- gpg_authentication "--export-options export-minimal --armor --export 0x${fingerprint}\!" > "${SYSDATADIR}/ssh_host_rsa_key.pub.gpg"
- log info "SSH host public key in OpenPGP form: ${SYSDATADIR}/ssh_host_rsa_key.pub.gpg"
-
- # show info about new key
- show_server_key
-}
-
# extend the lifetime of a host key:
extend_key() {
local fpr=$(fingerprint_server_key)
diff --git a/src/subcommands/ma/diagnostics b/src/subcommands/ma/diagnostics
new file mode 100755
index 0000000..3eadeed
--- /dev/null
+++ b/src/subcommands/ma/diagnostics
@@ -0,0 +1,12 @@
+#!/usr/bin/env bash
+
+# Monkeysphere authentication diagnostics subcommand
+#
+# The monkeysphere scripts are written by:
+# Jameson Rollins <jrollins@fifthhorseman.net>
+# Jamie McClelland <jm@mayfirst.org>
+# Daniel Kahn Gillmor <dkg@fifthhorseman.net>
+#
+# They are Copyright 2008, and are all released under the GPL, version 3
+# or later.
+
diff --git a/src/subcommands/ma/update-users b/src/subcommands/ma/update-users
new file mode 100755
index 0000000..a26d3fb
--- /dev/null
+++ b/src/subcommands/ma/update-users
@@ -0,0 +1,144 @@
+#!/usr/bin/env bash
+
+# Monkeysphere authentication update-users subcommand
+#
+# The monkeysphere scripts are written by:
+# Jameson Rollins <jrollins@fifthhorseman.net>
+# Jamie McClelland <jm@mayfirst.org>
+# Daniel Kahn Gillmor <dkg@fifthhorseman.net>
+#
+# They are Copyright 2008, and are all released under the GPL, version 3
+# or later.
+
+if [ "$1" ] ; then
+ # get users from command line
+ unames="$@"
+else
+ # or just look at all users if none specified
+ unames=$(getent passwd | cut -d: -f1)
+fi
+
+RETCODE=0
+
+# set mode
+MODE="authorized_keys"
+
+# set gnupg home
+GNUPGHOME="$GNUPGHOME_AUTHENTICATION"
+
+# check to see if the gpg trust database has been initialized
+if [ ! -s "${GNUPGHOME}/trustdb.gpg" ] ; then
+ failure "GNUPG trust database uninitialized. Please see MONKEYSPHERE-SERVER(8)."
+fi
+
+# make sure the authorized_keys directory exists
+mkdir -p "${SYSDATADIR}/authorized_keys"
+
+# loop over users
+for uname in $unames ; do
+ # check all specified users exist
+ if ! id "$uname" >/dev/null ; then
+ log error "----- unknown user '$uname' -----"
+ continue
+ fi
+
+ log verbose "----- user: $uname -----"
+
+ # make temporary directory
+ TMPLOC=$(mktemp -d ${MSTMPDIR}/tmp.XXXXXXXXXX) || failure "Could not create temporary directory!"
+
+ # trap to delete temporary directory on exit
+ trap "rm -rf $TMPLOC" EXIT
+
+ # create temporary authorized_user_ids file
+ TMP_AUTHORIZED_USER_IDS="${TMPLOC}/authorized_user_ids"
+ touch "$TMP_AUTHORIZED_USER_IDS"
+
+ # create temporary authorized_keys file
+ AUTHORIZED_KEYS="${TMPLOC}/authorized_keys"
+ touch "$AUTHORIZED_KEYS"
+
+ # set restrictive permissions on the temporary files
+ # FIXME: is there a better way to do this?
+ chmod 0700 "$TMPLOC"
+ chmod 0600 "$AUTHORIZED_KEYS"
+ chmod 0600 "$TMP_AUTHORIZED_USER_IDS"
+ chown -R "$MONKEYSPHERE_USER" "$TMPLOC"
+
+ # process authorized_user_ids file
+ log debug "checking for authorized_user_ids..."
+ # translating ssh-style path variables
+ authorizedUserIDs=$(translate_ssh_variables "$uname" "$AUTHORIZED_USER_IDS")
+ if [ -s "$authorizedUserIDs" ] ; then
+ # check permissions on the authorized_user_ids file path
+ if check_key_file_permissions "$uname" "$authorizedUserIDs" ; then
+ # copy user authorized_user_ids file to temporary
+ # location
+ cat "$authorizedUserIDs" > "$TMP_AUTHORIZED_USER_IDS"
+
+ # export needed variables
+ export AUTHORIZED_KEYS
+ export TMP_AUTHORIZED_USER_IDS
+
+ # process authorized_user_ids file, as monkeysphere user
+ su_monkeysphere_user \
+ ". ${SYSSHAREDIR}/common; process_authorized_user_ids $TMP_AUTHORIZED_USER_IDS"
+ RETURN="$?"
+ else
+ log debug "not processing authorized_user_ids."
+ fi
+ else
+ log debug "empty or absent authorized_user_ids file."
+ fi
+
+ # add user-controlled authorized_keys file if specified translate
+ # ssh-style path variables
+ rawAuthorizedKeys=$(translate_ssh_variables "$uname" "$RAW_AUTHORIZED_KEYS")
+ if [ "$rawAuthorizedKeys" != 'none' ] ; then
+ log debug "checking for raw authorized_keys..."
+ if [ -s "$rawAuthorizedKeys" ] ; then
+ # check permissions on the authorized_keys file path
+ if check_key_file_permissions "$uname" "$rawAuthorizedKeys" ; then
+ log verbose "adding raw authorized_keys file... "
+ cat "$rawAuthorizedKeys" >> "$AUTHORIZED_KEYS"
+ else
+ log debug "not adding raw authorized_keys file."
+ fi
+ else
+ log debug "empty or absent authorized_keys file."
+ fi
+ fi
+
+ # move the new authorized_keys file into place
+ if [ -s "$AUTHORIZED_KEYS" ] ; then
+ # openssh appears to check the contents of the authorized_keys
+ # file as the user in question, so the file must be readable
+ # by that user at least.
+
+ # but in general, we don't want the user tampering with this
+ # file directly, so we'll adopt this approach: Own the file by
+ # the monkeysphere-server invoker (usually root, but should be
+ # the same uid that sshd is launched as); change the group of
+ # the file so that members of the user's group can read it.
+
+ # FIXME: is there a better way to do this?
+ chown $(whoami) "$AUTHORIZED_KEYS" && \
+ chgrp $(id -g "$uname") "$AUTHORIZED_KEYS" && \
+ chmod g+r "$AUTHORIZED_KEYS" && \
+ mv -f "$AUTHORIZED_KEYS" "${SYSDATADIR}/authorized_keys/${uname}" || \
+ {
+ log error "Failed to install authorized_keys for '$uname'!"
+ rm -f "${SYSDATADIR}/authorized_keys/${uname}"
+ # indicate that there has been a failure:
+ RETURN=1
+ }
+ else
+ rm -f "${SYSDATADIR}/authorized_keys/${uname}"
+ fi
+
+ # unset the trap
+ trap - EXIT
+
+ # destroy temporary directory
+ rm -rf "$TMPLOC"
+ done
diff --git a/src/subcommands/mh/gen-key b/src/subcommands/mh/gen-key
new file mode 100755
index 0000000..37469c7
--- /dev/null
+++ b/src/subcommands/mh/gen-key
@@ -0,0 +1,118 @@
+#!/usr/bin/env bash
+
+# Monkeysphere host gen-key subcommand
+#
+# The monkeysphere scripts are written by:
+# Jameson Rollins <jrollins@fifthhorseman.net>
+# Jamie McClelland <jm@mayfirst.org>
+# Daniel Kahn Gillmor <dkg@fifthhorseman.net>
+#
+# They are Copyright 2008, and are all released under the GPL, version 3
+# or later.
+
+local keyType="RSA"
+local keyLength="2048"
+local keyUsage="auth"
+local keyExpire
+local revoker
+local hostName=$(hostname -f)
+local userID
+local keyParameters
+local fingerprint
+
+# check for presense of secret key
+# FIXME: is this the proper test to be doing here?
+fingerprint_server_key >/dev/null \
+ && failure "An OpenPGP host key already exists."
+
+# get options
+while true ; do
+ case "$1" in
+ -h|--hostname)
+ hostName="$2"
+ shift 2
+ ;;
+ -l|--length)
+ keyLength="$2"
+ shift 2
+ ;;
+ -e|--expire)
+ keyExpire="$2"
+ shift 2
+ ;;
+ -r|--revoker)
+ revoker="$2"
+ shift 2
+ ;;
+ *)
+ if [ "$(echo "$1" | cut -c 1)" = '-' ] ; then
+ failure "Unknown option '$1'.
+Type '$PGRM help' for usage."
+ fi
+ break
+ ;;
+ esac
+done
+
+userID="ssh://${hostName}"
+
+# prompt about key expiration if not specified
+keyExpire=$(get_gpg_expiration "$keyExpire")
+
+# set key parameters
+keyParameters=\
+"Key-Type: $keyType
+Key-Length: $keyLength
+Key-Usage: $keyUsage
+Name-Real: $userID
+Expire-Date: $keyExpire"
+
+# add the revoker field if specified
+# FIXME: the "1:" below assumes that $REVOKER's key is an RSA key.
+# FIXME: key is marked "sensitive"? is this appropriate?
+if [ "$revoker" ] ; then
+ keyParameters=\
+"${keyParameters}
+Revoker: 1:${revoker} sensitive"
+fi
+
+echo "The following key parameters will be used for the host private key:"
+echo "$keyParameters"
+
+read -p "Generate key? (Y/n) " OK; OK=${OK:=Y}
+if [ ${OK/y/Y} != 'Y' ] ; then
+ failure "aborting."
+fi
+
+# add commit command
+# must include blank line!
+keyParameters=\
+"${keyParameters}
+
+%commit
+%echo done"
+
+log verbose "generating host key..."
+echo "$keyParameters" | gpg_host --batch --gen-key
+
+# find the key fingerprint of the newly generated key
+fingerprint=$(fingerprint_server_key)
+
+# export host ownertrust to authentication keyring
+log verbose "setting ultimate owner trust for host key..."
+echo "${fingerprint}:6:" | gpg_authentication "--import-ownertrust"
+
+# translate the private key to ssh format, and export to a file
+# for sshs usage.
+# NOTE: assumes that the primary key is the proper key to use
+(umask 077 && \
+ gpg_host --export-secret-key "$fingerprint" | \
+ openpgp2ssh "$fingerprint" > "${SYSDATADIR}/ssh_host_rsa_key")
+log info "SSH host private key output to file: ${SYSDATADIR}/ssh_host_rsa_key"
+ssh-keygen -y -f "${SYSDATADIR}/ssh_host_rsa_key" > "${SYSDATADIR}/ssh_host_rsa_key.pub"
+log info "SSH host public key output to file: ${SYSDATADIR}/ssh_host_rsa_key.pub"
+gpg_authentication "--export-options export-minimal --armor --export 0x${fingerprint}\!" > "${SYSDATADIR}/ssh_host_rsa_key.pub.gpg"
+log info "SSH host public key in OpenPGP form: ${SYSDATADIR}/ssh_host_rsa_key.pub.gpg"
+
+# show info about new key
+show_server_key
diff --git a/src/subcommands/mh/import-key b/src/subcommands/mh/import-key
new file mode 100755
index 0000000..c33550b
--- /dev/null
+++ b/src/subcommands/mh/import-key
@@ -0,0 +1,85 @@
+#!/usr/bin/env bash
+
+# Monkeysphere host import-key subcommand
+#
+# The monkeysphere scripts are written by:
+# Jameson Rollins <jrollins@fifthhorseman.net>
+# Jamie McClelland <jm@mayfirst.org>
+# Daniel Kahn Gillmor <dkg@fifthhorseman.net>
+#
+# They are Copyright 2008, and are all released under the GPL, version 3
+# or later.
+
+local hostName=$(hostname -f)
+local keyFile="/etc/ssh/ssh_host_rsa_key"
+local keyExpire
+local userID
+
+# check for presense of secret key
+# FIXME: is this the proper test to be doing here?
+fingerprint_server_key >/dev/null \
+ && failure "An OpenPGP host key already exists."
+
+# get options
+while true ; do
+ case "$1" in
+ -h|--hostname)
+ hostName="$2"
+ shift 2
+ ;;
+ -f|--keyfile)
+ keyFile="$2"
+ shift 2
+ ;;
+ -e|--expire)
+ keyExpire="$2"
+ shift 2
+ ;;
+ *)
+ if [ "$(echo "$1" | cut -c 1)" = '-' ] ; then
+ failure "Unknown option '$1'.
+Type '$PGRM help' for usage."
+ fi
+ break
+ ;;
+ esac
+done
+
+if [ ! -f "$keyFile" ] ; then
+ failure "SSH secret key file '$keyFile' not found."
+fi
+
+userID="ssh://${hostName}"
+
+# prompt about key expiration if not specified
+keyExpire=$(get_gpg_expiration "$keyExpire")
+
+echo "The following key parameters will be used for the host private key:"
+echo "Import: $keyFile"
+echo "Name-Real: $userID"
+echo "Expire-Date: $keyExpire"
+
+read -p "Import key? (Y/n) " OK; OK=${OK:=Y}
+if [ ${OK/y/Y} != 'Y' ] ; then
+ failure "aborting."
+fi
+
+log verbose "importing ssh key..."
+# translate ssh key to a private key
+(umask 077 && \
+ pem2openpgp "$userID" "$keyExpire" < "$sshKey" | gpg_host --import)
+
+# find the key fingerprint of the newly converted key
+fingerprint=$(fingerprint_server_key)
+
+# export host ownertrust to authentication keyring
+log verbose "setting ultimate owner trust for host key..."
+echo "${fingerprint}:6:" | gpg_host "--import-ownertrust"
+echo "${fingerprint}:6:" | gpg_authentication "--import-ownertrust"
+
+# export public key to file
+gpg_authentication "--export-options export-minimal --armor --export 0x${fingerprint}\!" > "${SYSDATADIR}/ssh_host_rsa_key.pub.gpg"
+log info "SSH host public key in OpenPGP form: ${SYSDATADIR}/ssh_host_rsa_key.pub.gpg"
+
+# show info about new key
+show_server_key